Variables    = saveSScreen
Sprite.X     = Variables \ Variables += 1
Sprite.Y     = Variables \ Variables += 1
RowStart     = Variables \ Variables += 2
RowStartMask = Variables \ Variables += 1
PixelOffset  = Variables \ Variables += 2
PixelMask    = Variables \ Variables += 1
StringLength = Variables \ Variables += 2
WidthLimit   = Variables \ Variables += 1

	; Reset default X, Y to top left.
	xor a
	ld (Sprite.X),a
	ld (Sprite.Y),a
	
	; Get X coordinate.
	ld hl,XVar
	ld ix,Sprite.X
	call FetchTIOSVar

	; Get Y coordinate.
	ld hl,YVar
	ld ix,Sprite.Y
	call FetchTIOSVar
	
	; If X is negative, flip horizontal.	
	ld hl,$0B*256+$23 ; RRC E | INC HL
	ld a,(Sprite.X)
	or a
	jp p,+
	neg
	ld (Sprite.X),a
	ld hl,$03*256+$2B ; RLC E | DEC HL
+

	ld a,h
	ld (ShiftDestMask+1),a ; R?C ? is a prefixed instruction.
	ld a,l
	ld (ShiftDestOffset),a
	
	ld a,(Sprite.Y)
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	ld d,h
	ld e,l
	add hl,hl
	add hl,de
	ld de,plotSScreen
	add hl,de
	ld a,(Sprite.X)
	srl a
	srl a
	srl a
	ld e,a
	ld d,0
	add hl,de
	ld (RowStart),hl
	ld (PixelOffset),hl
	
	ld a,(Sprite.X)
	ld c,%10000000
	and 7
	jr z,+
	ld b,a
-	srl c
	djnz -
+	ld a,c
	ld (PixelMask),a
	ld (RowStartMask),a
	
	; Find string var.
	ld hl,SpriteVar
	rst rMov9ToOP1
	.bcall _ChkFindSym
	ret c ; String not found.
	ld a,b
	or a
	ret nz ; Archived.
	ex de,hl
	ld de,StringLength
	ldi
	ldi
	push hl	
	pop ix

	ld a,8
	ld (WidthLimit),a

DecodeSpriteLoop

	ld a,(WidthLimit)
	dec a
	ld (WidthLimit),a
	jp m,NextLine

DecodeSpriteLoopNotWrap

	call ReadString
	
	cp 'G'
	jr nz,NotG

NextLine
	; We've received a 'G' or run out of width.
	ld hl,(RowStart)
	ld de,12
	add hl,de
	ld (RowStart),hl
	ld (PixelOffset),hl
	ld a,(RowStartMask)
	ld (PixelMask),a
	ld a,8
	ld (WidthLimit),a
	jr DecodeSpriteLoop

NotG
	
	; Not 'G', assume it's a normal byte.
	call DecodeNybble
	jr c,DecodeSpriteLoopNotWrap

	add a,a
	add a,a
	add a,a
	add a,a
	
	ld d,a ; d = byte to output.
	
	ld a,(PixelMask)
	ld e,a ; e = pixel mask.
	
	ld hl,(PixelOffset)
	ld b,4
-	rlc d
	jr nc,+
	ld a,e
	or (hl)
	ld (hl),a
+
ShiftDestMask
	rrc e
	jr nc,+
ShiftDestOffset
	inc hl
	ld (PixelOffset),hl
+	djnz -
	ld a,e
	ld (PixelMask),a

	jr DecodeSpriteLoop

FinishedSpriteLoop

	.bcall _GrBufCpy
	res graphDraw,(iy+graphFlags)
	ret

; Given an ASCII char in A (0~9, A~F), return the hex nybble.
; Sets carry flag if character is not in range.
DecodeNybble
	cp 'A'
	jr c,NotLetter
	sub 'A'-$A
	cp $F+1
	ccf
	ret c
	and $0F
	or a
	ret
NotLetter
	sub '0'
	cp 9+1
	ccf
	ret c
	and $0F
	or a
	ret

; HL -> Pointer to variable name, IX -> Pointer to destination.
FetchTIOSVar
	rst rMov9ToOP1
	push ix
	.bcall _ChkFindSym
	pop ix
	ret c
	ld a,b
	or a
	ret nz
	ex de,hl
	rst rMov9ToOP1
	push ix
	.bcall _ConvOP1
	ld ix,OP1
	bit 7,(ix+0)
	jr z,+
	neg
+	pop ix
	ld (ix+0),a
	ret

; Read a byte from the string. If at the end of the string, exit.
ReadString
	ld hl,(StringLength)
	ld a,h
	or l
	jr nz,NotEndOfString
	pop hl
	jp FinishedSpriteLoop
NotEndOfString
	dec hl
	ld (StringLength),hl
	ld a,(ix+0)
	inc ix
	ret
	
XVar      .db RealObj, tI, 0, 0, 0, 0, 0, 0, 0
YVar      .db RealObj, tJ, 0, 0, 0, 0, 0, 0, 0
SpriteVar .db StringObj, tVarStrng, tStr4, 0, 0, 0, 0, 0, 0